#include <QApplication>
#include <QDBusConnection>
#include <QDBusInterface>
#include <QDBusReply>
#include <iostream>
#include <stdint.h>

class ScreenSaverDBus
{
  public:
    ScreenSaverDBus() :
        m_bus(QDBusConnection::sessionBus()),
        m_interface(new QDBusInterface("org.freedesktop.ScreenSaver",
                                                   "/ScreenSaver",
                                                   "org.freedesktop.ScreenSaver",
                                                   m_bus))
    {
    };
    ~ScreenSaverDBus() 
    {
        delete m_interface;
    };
    void Spork(void)
    {
#define m_app               QString("MythTV")
#define m_reason            QString("Watching TV")
        QDBusReply<uint32_t> reply = m_interface->call(QDBus::Block, "Inhibit", m_app, m_reason);
        if (reply.isValid())
        {
            std::cout << "Cookie is " << reply.value() << std::endl;
        }
        else
        {
            std::cout << "Call failed" << std::endl;
        }
    }

  private:
    QDBusConnection m_bus;
    QDBusInterface  *m_interface;
};

int main(int argv, char **args)
{
	QApplication app(argv, args);
    ScreenSaverDBus ss;
    ss.Spork();
    return app.exec();
}
